<?php

/**
 * @package     com_symdef for Joomla! 1.5
 * @version	$Id: symbolfile.php 2010-09-02 10:07:31Z Hernán Roa $
 * @author      Hernán Roa Reyes
 * @copyright	(C) 2010 - 2012 Hernán Roa Reyes.
 * @license	GNU/GPLv3 http://www.gnu.org/copyleft/gpl.html
 * See license.txt
 * Symdef is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
jimport('joomla.client.helper');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');


class symdefControllerSymbolfile extends JController {

    /**
     * Custom Constructor
     */
    function __construct($default = array()) {
        parent::__construct($default);

        $this->registerTask( 'unpublish',   'publish');
        $this->registerTask( 'preview',     'display');
        $this->registerTask( 'edit',        'display');
        $this->registerTask( 'add' ,        'display' );
    }

    function display() {
        $actEvt = JRequest::getVar('task');

        switch($actEvt){
            case 'add'     :
            {
                    JRequest::setVar( 'hidemainmenu', 1 );
                    JRequest::setVar( 'layout', 'form'  );
                    JRequest::setVar( 'view', 'symbolfile'  );
                    JRequest::setVar( 'edit', false  );
            } break;
            case 'edit'    :
            {
                    JRequest::setVar( 'hidemainmenu', 1 );
                    JRequest::setVar( 'layout', 'form'  );
                    JRequest::setVar( 'view', 'symbolfile'  );
                    JRequest::setVar( 'edit', true  );
            } break;
        }

        if (JRequest::getVar('task') == 'remove') {
            $this->remove();
        }

        if (JRequest::getVar('task') == 'save') {
            $this->addTerm();
        }

        if (JRequest::getVar('task') == 'update') {
            $this->editTerm();
        }

        if (JRequest::getVar('task') == 'saveorder') {
            $this->saveOrder();
        }

        if (JRequest::getVar('task') == 'orderup' || JRequest::getVar('task') == 'orderdown') {
            $this->setOrder(JRequest::getVar('task'));
        }

        if(JRequest::getVar('task') === 'publish' || JRequest::getVar('task') === 'unpublish'){
            $this->publish(JRequest::getVar('task'));
        }

        //Set the default view, just in case
        $view = JRequest::getCmd('view');

        if (empty($view)) {
            JRequest::setVar('view', 'symbolfile');
        };

        parent::display();
    }

    function addTerm() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $db = & JFactory::getDBO();

        $msg = '';

        $def        = JRequest::getVar('descrip', NULL, 'post', 'none', 4);
        $published  = JRequest::getVar('published', NULL, 'post');
        $date       = date("Y-m-d");
        $File       = $this->upload();
        $nameFile   = $File[0];
        $sizeFile   = round((int)$File[1]/1000);

        if(!empty($def)) {
            $def = str_replace('"', '&#34;', str_replace("'", '&#39;', $def));
        }

        if($File){
            $qry = "INSERT INTO #__symdefFiles (nomFile, descrip, size, datePub, published) " .
                " VALUES('$nameFile', '$def', '$sizeFile', '$date', '$published')";

            $db->setQuery($qry);

            if(!empty($nameFile)){
                if (!$db->query()) {
                    $msg .= $db->getErrorMsg() . " ";
                }
            }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symFile', $msg);
    }

    function editTerm() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');
        var_dump($_REQUEST);
        $db = & JFactory::getDBO();
        $cid = JRequest::getVar('s_id');

        $msg = '';

        $def        = JRequest::getVar('def', NULL, 'post', 'none', 4);
        $file 	= JRequest::getVar( 'sFile', '', 'files', 'array' );
        $published  = JRequest::getVar('published', NULL, 'post');
        $date       = date("Y-m-d");

        if(!empty($def)) {
            $def = str_replace('"', '&#34;', str_replace("'", '&#39;', $def));
        }

        if(empty($file['name'])){
            $qry = "UPDATE #__symdefFiles SET descrip='" . $def .
                "', published='" . $published .
                "' WHERE id='$cid'";

            $db->setQuery($qry);

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }
        } else {
            $File       = $this->upload();

            if($File){
                $nameFile   = $File[0];
                $sizeFile   = round((int)$File[1]/1000);

                $this->delFile($cid);

                $qry = "UPDATE #__symdefFiles SET nomFile='" . $nameFile .
                    "', descrip='" . $def .
                    "', size='" . $sizeFile .
                    "', published='" . $published .
                    "' WHERE id='$cid'";

                $db->setQuery($qry);

                if (!$db->query()) {
                    $msg .= $db->getErrorMsg() . " ";
                }
            } else {
                $qry = "UPDATE #__symdefFiles SET descrip='" . $def .
                "', published='" . $published .
                "' WHERE id='$cid'";

                $db->setQuery($qry);

                if (!$db->query()) {
                    $msg .= $answ->getError() . " ";
                }
            }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symFile', $msg);
    }

    function remove() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $db = & JFactory::getDBO();
        $cid = JRequest::getVar('cid', array(), '', 'array');

        $msg = '';

        for ($i = 0, $n = count($cid); $i < $n; $i++) {
            $this->delFile($cid[$i]);

            $qry = "DELETE FROM #__symdefFiles WHERE id='$cid[$i]'";

                    $db->setQuery($qry);

                    if (!$db->query()) {
                        $msg .= $db->getErrorMsg() . " ";
                    }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symFile', $msg);
    }

    function cancel() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symFile');
    }

    function publish($state){
        global $mainframe;

        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $db 	=& JFactory::getDBO();
        $user 	=& JFactory::getUser();

        $cid		= JRequest::getVar( 'cid', array(), '', 'array' );
        $publish	= ( $state == 'publish' ? 1 : 0 );

        JArrayHelper::toInteger($cid);

        if (count( $cid ) < 1) {
                $action = $publish ? 'publish' : 'unpublish';
                JError::raiseError(500, JText::_( 'Select an item to' .$action, true ) );
        }

        $cids = implode( ',', $cid );

        $query = 'UPDATE #__symdefFiles'
        . ' SET published = ' . (int) $publish
        . ' WHERE id IN ( '. $cids .' )';

        $db->setQuery( $query );

        if (!$db->query()) {
                JError::raiseError(500, $db->getErrorMsg() );
        }

        $mainframe->redirect( 'index.php?option=com_symdef&optCtrl=symFile' );
    }

    function upload(){
        global $mainframe;

        // Check for request forgeries
        JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

        $file 	= JRequest::getVar( 'sFile', '', 'files', 'array' );
        $err	= null;

        $path	= JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_symdef'.DS.'symFiles';// we use viewback to get right path
        
        if($file['size'] <= '10000000'){ //10MB

            // Make the filename safe
            if (isset($file['name'])) {
                $file['name']	= JFile::makeSafe($file['name']);
            }


        // All HTTP header will be overwritten with js message
            if (isset($file['name'])) {
                if (!empty($file['name'])) {
                    $filepath = $path.DS.strtolower($file['name']);
                    
                    if (JFile::exists($filepath)) {
                        JError::raiseNotice(100, JText::_('SYMDEF_ERROR_FILENAME'));
                        // REDIRECT
                        return false;
                    }

                    if (!JFile::upload($file['tmp_name'], $filepath)) {
                        JError::raiseWarning(100, 'ERROR. '.JText::_('SYMDEF_ERROR_UPLOADFILE'));
                        // REDIRECT
                        return false;
                    } else {
                        $mainframe->enqueueMessage(JText::_('SYMDEF_FILE_OKUPLOAD'));
                        // REDIRECT
                        return array(strtolower($file['name']), $file['size']);
                    }
                }
            }
        }
    }

    function delFile($id){
        // Check for request forgeries
        JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

        $db	=& JFactory::getDBO();

        $query = "SELECT nomFile FROM #__symdefFiles WHERE id='$id'";

	$db->setQuery( $query );
	$file = $db->loadResult();

        $filepath = JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_symdef'.DS.'symFiles'.DS.$file;

        if($file){
            if (JFile::exists($filepath)) {
                if(JFile::delete($filepath)){
                    return true;
                } else {
                    JError::raiseWarning(100, 'Error. '.JText::_('SYMDEF_ERROR_UPLOADFILE'));
                    return false;
                }
            }
        }
    }
}