<?php

/**
 * @package     com_symdef for Joomla! 1.5
 * @version	$Id: symbollist.php 2010-09-02 10:07:31Z Hernán Roa $
 * @author      Hernán Roa Reyes
 * @copyright	(C) 2010 - 2012 Hernán Roa Reyes.
 * @license	GNU/GPLv3 http://www.gnu.org/copyleft/gpl.html
 * See license.txt
 * Symdef is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
jimport('joomla.client.helper');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');


class symdefControllerSymbollist extends JController {

    /**
     * Custom Constructor
     */
    function __construct($default = array()) {
        parent::__construct($default);

        $this->registerTask( 'unpublish',   'publish');
        $this->registerTask( 'preview',     'display');
        $this->registerTask( 'edit',        'display');
        $this->registerTask( 'add' ,        'display' );
    }

    function display() {
        $actEvt = JRequest::getVar('task');
        
        switch($actEvt){
            case 'add'     :
            {
                    JRequest::setVar( 'hidemainmenu', 1 );
                    JRequest::setVar( 'layout', 'form'  );
                    JRequest::setVar( 'view', 'symboldef'  );
                    JRequest::setVar( 'edit', false  );
            } break;
            case 'edit'    :
            {
                    JRequest::setVar( 'hidemainmenu', 1 );
                    JRequest::setVar( 'layout', 'form'  );
                    JRequest::setVar( 'view', 'symboldef'  );
                    JRequest::setVar( 'edit', true  );
            } break;
        }

        if (JRequest::getVar('task') == 'remove') {
            $this->remove();
        }

        if (JRequest::getVar('task') == 'save') {
            $this->addTerm();
        }

        if (JRequest::getVar('task') == 'update') {
            $this->editTerm();
        }

        if (JRequest::getVar('task') == 'saveorder') {
            $this->saveOrder();
        }

        if (JRequest::getVar('task') == 'orderup' || JRequest::getVar('task') == 'orderdown') {
            $this->setOrder(JRequest::getVar('task'));
        }

        if(JRequest::getVar('task') === 'publish' || JRequest::getVar('task') === 'unpublish'){
            $this->publish(JRequest::getVar('task'));
        }
        
        //Set the default view, just in case
        $view = JRequest::getCmd('view');

        if (empty($view)) {
            JRequest::setVar('view', 'symboldef');
        };
        
        parent::display();
    }

    function addTerm() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $db = & JFactory::getDBO();
        $cid = JRequest::getVar('cid', array(), '', 'array');

        $order      = NULL;

        $qry = "SELECT IF(MAX(orderSym) IS NULL OR MAX(orderSym) = 0, 1, MAX(orderSym) + 1) FROM #__symdef";

        $db->setQuery($qry);

        $order      = $db->loadResult();
        
        $msg = '';

        $title      = JRequest::getVar('title', NULL, 'post', 'none', 4);
        $ititle     = JRequest::getVar('ititle', NULL, 'post', 'none', 4);
        $def        = JRequest::getVar('def', NULL, 'post', 'none', 4);
        $published  = JRequest::getVar('published', NULL, 'post');
        $icon       = $this->upload();

        if(!empty($def)) {
            $def = str_replace('"', '&#34;', str_replace("'", '&#39;', $def));
        }

        if($icon){
            $qry = "INSERT INTO #__symdef (title, def, ititle, icon, orderSym, published) " .
                " VALUES('$title', '$def', '$ititle', '$icon', '$order', '$published')";
            $db->setQuery($qry);

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }

        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symList', $msg);
    }

    function editTerm() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $db = & JFactory::getDBO();
        $cid = JRequest::getVar('s_id');
        
        $msg = '';

        $title      = JRequest::getVar('title', NULL, 'post', 'none', 4);
        $ititle     = JRequest::getVar('ititle', NULL, 'post', 'none', 4);
        $def        = JRequest::getVar('def', NULL, 'post', 'none', 4);
        $published  = JRequest::getVar('published', NULL, 'post');
        $file       = JRequest::getVar( 'img', '', 'files', 'array' );

        if(!empty($def)) {
            $def = str_replace('"', '&#34;', str_replace("'", '&#39;', $def));
        }

        if ($file['name']) {
            $icon = $this->upload();

            if ($icon) {
                $this->delImg($cid);
                
                $qry = "UPDATE #__symdef SET title='" . $title .
                        "', def='" . $def .
                        "', ititle='" . $ititle .
                        "', icon='" . $icon .
                        "', published='" . $published .
                        "' WHERE id='$cid'";

                $db->setQuery($qry);

                if (!$db->query()) {
                    $msg .= $db->getErrorMsg() . " ";
                }
            } else {
                $qry = "UPDATE #__symdef SET title='" . $title .
                        "', def='" . $def .
                        "', ititle='" . $ititle .
                        "', published='" . $published .
                        "' WHERE id='$cid'";

                $db->setQuery($qry);

                if (!$db->query()) {
                    $msg .= $db->getErrorMsg() . " ";
                }
            }
        } else {
            $qry = "UPDATE #__symdef SET title='" . $title .
                    "', def='" . $def .
                    "', ititle='" . $ititle .
                    "', published='" . $published .
                    "' WHERE id='$cid'";

            $db->setQuery($qry);

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symList', $msg);
    }

    function remove() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $db = & JFactory::getDBO();
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        $msg = '';
        
        for ($i = 0, $n = count($cid); $i < $n; $i++) {
            $this->delImg($cid[$i]);

            $qry = "DELETE FROM #__symdef WHERE id='$cid[$i]'";

                    $db->setQuery($qry);

                    if (!$db->query()) {
                        $msg .= $db->getErrorMsg() . " ";
                    }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symList', $msg);
    }

    function cancel() {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');

        $id = JRequest::getVar('id', 0, '', 'int');
        $db = & JFactory::getDBO();
        $row = & JTable::getInstance('symdef', 'Table');

        $row->checkin($id);
        $this->setRedirect('index.php?option=com_symdef&optCtrl=symList');
    }

    function publish($state){
        global $mainframe;

        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $db 	=& JFactory::getDBO();
        $user 	=& JFactory::getUser();

        $cid		= JRequest::getVar( 'cid', array(), '', 'array' );
        $publish	= ( $state == 'publish' ? 1 : 0 );

        JArrayHelper::toInteger($cid);

        if (count( $cid ) < 1) {
                $action = $publish ? 'publish' : 'unpublish';
                JError::raiseError(500, JText::_( 'Select an item to' .$action, true ) );
        }

        $cids = implode( ',', $cid );

        $query = 'UPDATE #__symdef'
        . ' SET published = ' . (int) $publish
        . ' WHERE id IN ( '. $cids .' )';

        $db->setQuery( $query );

        if (!$db->query()) {
                JError::raiseError(500, $db->getErrorMsg() );
        }
        
        $mainframe->redirect( 'index.php?option=com_symdef&optCtrl=symList' );
    }

    function setOrder ($type) {
        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $db 	=& JFactory::getDBO();
        $user 	=& JFactory::getUser();

        $cid	= JRequest::getVar( 'cid', array(), '', 'array' );

        JArrayHelper::toInteger($cid);

        $query = "SELECT orderSym FROM #__symdef WHERE id = '$cid[0]' ";

        $db->setQuery( $query );

        $currentOrder   = $db->loadResult();
        $prevOrder      = (int)$currentOrder - 1;
        $nextOrder      = (int)$currentOrder + 1;

        if($type === 'orderup') {
            $query = "UPDATE #__symdef SET orderSym = 0 WHERE id = '$cid[0]' ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }

            $query = "UPDATE #__symdef SET orderSym = '$currentOrder' WHERE orderSym = '$prevOrder' ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }

            $query = "UPDATE #__symdef SET orderSym = '$prevOrder' WHERE orderSym = 0 ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }
        } elseif($type === 'orderdown') {
            $query = "UPDATE #__symdef SET orderSym = 0 WHERE id = '$cid[0]' ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }

            $query = "UPDATE #__symdef SET orderSym = '$currentOrder' WHERE orderSym = '$nextOrder' ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }

            $query = "UPDATE #__symdef SET orderSym = '$nextOrder' WHERE orderSym = 0 ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symList');
    }

    function saveOrder() {
        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $db 	=& JFactory::getDBO();
        $user 	=& JFactory::getUser();

        $cid	= JRequest::getVar( 'cid', array(), '', 'array' );
        $order	= JRequest::getVar( 'order', array(), '', 'array' );

        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);

        for ( $i = 0; $i < count($cid); $i++ ){
            $query = "UPDATE #__symdef SET orderSym = '$order[$i]' WHERE id = '$cid[$i]' ";

            $db->setQuery( $query );

            if (!$db->query()) {
                $msg .= $db->getErrorMsg() . " ";
            }
        }

        $this->setRedirect('index.php?option=com_symdef&optCtrl=symList');
    }

    function upload(){
        global $mainframe;

        // Check for request forgeries
        JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

        $file 	= JRequest::getVar( 'img', '', 'files', 'array' );
        $err	= null;

        $path	= JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_symdef'.DS.'images';// we use viewback to get right path
        
        if($file['size'] <= '8000'){

            // Make the filename safe
            if (isset($file['name'])) {
                $file['name']	= JFile::makeSafe($file['name']);
            }


        // All HTTP header will be overwritten with js message
            if (isset($file['name'])) {
                if (!empty($file['name'])) {
                    $filepath = $path.DS.strtolower($file['name']);

                    if (JFile::exists($filepath)) {
                        JError::raiseNotice(100, JText::_('SYMDEF_ERROR_FILENAME'));
                        // REDIRECT
                        return false;
                    }

                    if (!JFile::upload($file['tmp_name'], $filepath)) {
                        JError::raiseWarning(100, 'ERROR. '.JText::_('SYMDEF_ERROR_UPLOADFILE'));
                        // REDIRECT
                        return false;
                    } else {
                        $mainframe->enqueueMessage(JText::_('SYMDEF_FILE_OKUPLOAD'));
                        // REDIRECT
                        return strtolower($file['name']);
                    }
                }
            } 
        }
    }

    function delImg($id){
        // Check for request forgeries
        JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

        $db	=& JFactory::getDBO();

        $query = "SELECT icon FROM #__symdef WHERE id='$id'";

	$db->setQuery( $query );
	$file = $db->loadResult();

        $filepath = JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_symdef'.DS.'images'.DS.$file;
        
        if($file && $file != 'btn_down.png'){
            if (JFile::exists($filepath)) {
                if(JFile::delete($filepath)){
                    return true;
                } else {
                    JError::raiseWarning(100, 'Error. '.JText::_('SYMDEF_ERROR_UPLOADFILE'));
                    return false;
                }
            }
        }
    }
}