<?php
/**
* @package      com_symdef for Joomla! 1.5
* @version	$Id: view.html.php 2010-09-02 10:07:31Z Hernán Roa $
* @author       Hernán Roa Reyes
* @copyright	(C) 2010 - 2012 Hernán Roa Reyes.
* @license	GNU/GPLv3 http://www.gnu.org/copyleft/gpl.html
* See license.txt
* Symdef is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class symdefViewSymbolstats extends JView{
    function display( $tpl = null ){
        global $mainframe, $option;

        $document	= JFactory::getDocument();
        $document->addScript(JURI::base() . 'components/com_symdef/style/symdef.js');

        $db			=& JFactory::getDBO();
        $filter_order		= $mainframe->getUserStateFromRequest( "$option.filter_order_Quest",        'filter_order',	'm.datePub',	'cmd' );
        $filter_order_Dir	= $mainframe->getUserStateFromRequest( "$option.filter_order_Dir_Quest",    'filter_order_Dir',	'',		'word' );
        $filter_state		= $mainframe->getUserStateFromRequest( "$option.filter_state_Quest",        'filter_state',	'',		'word' );
        $search			= $mainframe->getUserStateFromRequest( "$option.search_Quest",              'search',		'',		'string' );
        $search			= JString::strtoupper( $search );

        $limit                  = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
        $limitstart             = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );

        $where = array();

        if ( $filter_state ){
            if ( $filter_state == 'P' ){
                    $where[] = 'm.published = 1';
            } else if ($filter_state == 'U' ){
                    $where[] = 'm.published = 0';
            }
        }

        if ($search){
                $where[] = 'LOWER(m.nomFile ) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
        }

        $where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

        $ordField = array('m.nomFile', 'm.size', 'datePubli', 'numdownload', 'b.name', 'b.email', 'm.id');

        $filter_order       = (in_array($filter_order, $ordField)) ? $filter_order : 'numdownload';
        $filter_order_Dir   = (in_array($filter_order_Dir, $ordField)) ? $filter_order_Dir : '';

        $orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;

        $query = 'SELECT COUNT(m.id)'
        . ' FROM #__symdefFiles AS m'
        . $where;

        $db->setQuery( $query );
        $total = $db->loadResult();

        jimport('joomla.html.pagination');
        $pagination = new JPagination( $total, $limitstart, $limit );

        $query = 'SELECT m.id, m.nomFile, m.size, m.checked_out, DATE_FORMAT(m.datePub, "%d-%m-%Y") AS datePubli, COUNT(a.id) AS numdownload, b.name, b.email FROM #__symdefFiles AS m '
        . 'INNER JOIN (#__symdefDownloadStats AS a INNER JOIN #__users AS b ON a.idUser=b.id) ON m.id=a.idFile '
        . $where
        . ' GROUP BY b.id, m.nomFile'
        . $orderby
        ;
        $db->setQuery( $query, $pagination->limitstart, $pagination->limit );
        $rows = $db->loadObjectList();

        if ($db->getErrorNum()) {
                echo $db->stderr();
                return false;
        }

        
        // state filter
        $lists['state']	= JHTML::_('grid.state',  $filter_state );

        // table ordering
        $lists['order_Dir']	= $filter_order_Dir;
        $lists['order']		= $filter_order;

        // search filter
        $lists['search']= $search;

        $this->assignRef('user',	JFactory::getUser());
        $this->assignRef('lists',	$lists);
        $this->assignRef('items',	$rows);
        $this->assignRef('pagination',	$pagination);

        parent::display($tpl);
    }
}