-- @package     com_eglossary for Joomla! 1.5
-- @version	$Id: eglossary_install.sql 2010-09-02 10:07:31Z Hernán Roa $
-- @author      Hernán Roa Reyes
-- @copyright	(C) 2010 - 2012 Hernán Roa Reyes.
-- @license	GNU/GPLv3 http://www.gnu.org/copyleft/gpl.html
-- See license.txt
-- flexam is free software. This version may have been modified pursuant
-- to the GNU General Public License, and as distributed it includes or
-- is derivative of works licensed under the GNU General Public License or
-- other free or open source software licenses.

DROP TABLE IF EXISTS `#__symdef`;
DROP TABLE IF EXISTS `#__symdefDownloadStats`;
DROP TABLE IF EXISTS `#__symdefFiles`;
DROP TABLE IF EXISTS `#__symdef_conf`;

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `#__symdef`
--

CREATE TABLE IF NOT EXISTS `#__symdef` (
  `id` bigint(20) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `def` text,
  `ititle` varchar(255) DEFAULT NULL,
  `icon` varchar(255) DEFAULT NULL,
  `published` tinyint(1) DEFAULT NULL,
  `checked_out` tinyint(1) DEFAULT NULL,
  `orderSym` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Estructura de tabla para la tabla `#__symdefDownloadStats`
--

CREATE TABLE IF NOT EXISTS `#__symdefDownloadStats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `idUser` int(11) NOT NULL,
  `idFile` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_file_idFIle` (`idFile`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Volcar la base de datos para la tabla `#__symdefDownloadStats`
--

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `#__symdefFiles`
--

CREATE TABLE IF NOT EXISTS `#__symdefFiles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nomFile` varchar(255) NOT NULL,
  `descrip` text NOT NULL,
  `size` int(11) NOT NULL,
  `datePub` date DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Volcar la base de datos para la tabla `#__symdefFiles`
--


-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `#__symdef_conf`
--

CREATE TABLE IF NOT EXISTS `#__symdef_conf` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `param` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- Volcar la base de datos para la tabla `#__symdef_conf`
--

INSERT INTO `#__symdef_conf` (`id`, `param`, `value`) VALUES
(1, 'titleComponent', 'Title'),
(2, 'height', '600'),
(3, 'numCol', '4');

--
-- Filtros para las tablas descargadas (dump)
--

--
-- Filtros para la tabla `#__symdefDownloadStats`
--
ALTER TABLE `#__symdefDownloadStats`
  ADD CONSTRAINT `#__symdefDownloadStats_ibfk_1` FOREIGN KEY (`idFile`) REFERENCES `#__symdefFiles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;


--
-- Configuracion del menu
--

CREATE TABLE IF NOT EXISTS `#__symdef_tmpId` ( `id` int(11) NULL ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__symdef_tmpId` (`id`) (SELECT MAX(id) + 1 FROM #__components);

UPDATE `#__components` SET `id` = (SELECT id FROM `#__symdef_tmpId`) WHERE name='Symdef';

INSERT INTO `#__components` (`name`, `link`, `menuid`, `parent`, `admin_menu_link`, `admin_menu_alt`, `option`, `ordering`, `admin_menu_img`, `iscore`, `params`, `enabled`) VALUES
('Symdef', 'option=com_symdef', 0, 0, 'option=com_symdef', 'Symdef', 'com_symdef', 0, 'js/ThemeOffice/component.png', 0, '', 1),
('Definition of Symbols', '', 0, (SELECT id FROM `#__symdef_tmpId`), 'option=com_symdef&optCtrl=symList', 'Definition of Symbols', 'com_symdef', 1, 'js/ThemeOffice/component.png', 0, '', 1),
('File Management', '', 0, (SELECT id FROM `#__symdef_tmpId`), 'option=com_symdef&optCtrl=symFile', 'File Management', 'com_symdef', 2, 'js/ThemeOffice/component.png', 0, '', 1),
('Download Statistics', '', 0, (SELECT id FROM `#__symdef_tmpId`), 'option=com_symdef&optCtrl=symDsta', 'Download Statistics', 'com_symdef', 3, 'js/ThemeOffice/component.png', 0, '', 1),
('General Settings', '', 0, (SELECT id FROM `#__symdef_tmpId`), 'option=com_symdef&optCtrl=symConf', 'General Settings', 'com_symdef', 4, 'js/ThemeOffice/component.png', 0, '', 1);

UPDATE `#__symdef_tmpId` SET `id` = (SELECT id FROM `#__components` WHERE name='Symdef');

DROP TABLE `#__symdef_tmpId`;
