<?php
/**
* @package      com_symdef for Joomla! 1.5
* @version	$Id: view.html.php 2010-09-02 10:07:31Z Hernán Roa $
* @author       Hernán Roa Reyes
* @copyright	(C) 2010 - 2012 Hernán Roa Reyes.
* @license	GNU/GPLv3 http://www.gnu.org/copyleft/gpl.html
* See license.txt
* Symdef is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');


class symdefViewShow extends JView {
    function display($tpl = null) {
        $model      =& $this->getModel();
        $symbol     = $this->tableSymbol($model->getSymbol());
        $definition = $this->symbolDefinition($model->getSymbol());
        $conf       = $model->getConf();

        $this->assignRef('conf',$conf);
        $this->assignRef('symbol',$symbol);
        $this->assignRef('definition',$definition);

        parent::display($tpl);
    }

    function symbolDefinition ($obj=array()) {
        $out = NULL;
        
        if(!empty($obj[0])){
            $numObj = count($obj);
            $out = '<div name="#s_definition">';

            for($i = 0; $i < $numObj; $i++) {
                if( $i == 0 ) {
                    $out .= '<div id="symdef' . $obj[$i]->id . '" style="display:block" class="dspSymDef">' . "\n";
                    $out .= '<h2>' . $obj[$i]->title . '</h2>' . "\n";
                    $out .= '<p>' . $obj[$i]->def . '</p>' . "\n";
                    $out .= '</div>' . "\n";
                } else {
                    $out .= '<div id="symdef' . $obj[$i]->id . '" style="display:none" class="dspSymDef">' . "\n";
                    $out .= '<h2>' . $obj[$i]->title . '</h2>' . "\n";
                    $out .= '<p>' . $obj[$i]->def . '</p>' . "\n";
                    $out .= '</div>' . "\n";
                }
            }
        }

        return $out . '</div>';
    }

    function tableSymbol ($obj=array()) {
        $out        = NULL;
        $model      =& $this->getModel();
        $conf       = $model->getConf();
        define('IMG_PATH', 'administrator/components/com_symdef/images/');

        if(!empty($obj[0])){
            $numObj = count($obj);
            $out = '<table cellspacing="2">' . "\n" . '<tr>' . "\n";

            for($i = 0; $i < $numObj; $i++) {
                if( $i > 0 && ($i % $conf[2]->value) == 0 ) {
                    $out .= '</tr>' . "\n" . '</table>';
                    $out .= '<table cellspacing="2">' . "\n" . '<tr>' . "\n";
                    $out .= '<td>' . "\n";
                    $out .= '<a href="#s_definition" onclick="javascript:showSymbolDefinition(\'symdef' . $obj[$i]->id . '\')"><div id="symbutton" ><p><img src="'. IMG_PATH . $obj[$i]->icon . '" alt="image" /></p><p>' . $obj[$i]->ititle . '</p></div></a>' . "\n";
                    $out .= '</td>' . "\n";
                } else {
                    $out .= '<td>' . "\n";
                    $out .= '<a href="#s_definition" onclick="javascript:showSymbolDefinition(\'symdef' . $obj[$i]->id . '\')"><div id="symbutton" ><p><img src="'. IMG_PATH . $obj[$i]->icon . '" alt="image" /></p><p>' . $obj[$i]->ititle . '</p></div></a>' . "\n";
                    $out .= '</td>' . "\n";
                }
            }

            $out .= '</tr>' . "\n" . '</table>';
        }

        return $out;
    }

    function setLinkDl ($bdy) {
        $config =& JComponentHelper::getParams( 'com_symdef' );

        $lnk  = $config->get('link');
        $targ = $config->get('target', 1);

        if($lnk == ''){
            $lnk  = '#';
        }

        if($targ == ''){
            $targ =  1;
        }

        $html    = NULL;
        $a       = NULL;

        if ($lnk != '') {
            switch ($targ) {
                // cases are slightly different
                case 1:
                    // open in a new window
                    $a = '<a href="' . $lnk . '" target="_blank">';
                    break;

                case 2:
                    // open in a popup window
                    $a = "<a href=\"#\" onClick=\"javascript:window.open('" . $lnk . "', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550');\">";
                    break;

                default: // formerly case 2
                    // open in parent window
                    $a = '<a href="' . $lnk . '">';
                    break;
            }

            $html = $a . $bdy . '</a>';
        } else {
            $html = $bdy;
        }

        return $html;
    }
}
?>
